// $Id: Gandharva.h,v 1.21 2002/08/11 01:39:23 Yoshi Exp $
// Copyright (C) 2000-2002 HOSHINO Yoshifumi
// {vO̓t[E\tgEFAłBρEĔzz GNU GPL o[WQ
// i͂ȍ~jQƂĂB

#ifndef _H_GANDHARVA
#define _H_GANDHARVA

#include <windows.h>
#include "banginterface.h"
#include "base.h"

#include "GandharvaSettings.h"
#include "PlayerDataContainer.h"
#include "Winamp3Func.h"
#include "WinampFunc.h"

#define WC_LSDESKTOP        "DesktopBackgroundClass"
#define WINDOWCLASS_DLL     "GandharvaClass"

#define MAGICDWORD         0x49474541

#define TIMERID		DWORD

enum {
  USERBM_TOGGLE=0,
  USERBM_SHOW,
  USERBM_HIDE,
  USERBM_TOGGLE_TIME,
  USERBM_DISPMENU,
  USERBM_SNDVOL,
  USERBM_TOGGLE_ONTOP,
  USERBM_ONTOP,
  USERBM_NOT_ONTOP,

  USERBM_AMP_POWER=10000,
  USERBM_AMP_COMMANDEX,
};

//Parse Click Map
#define PCM_OTHER 0x0000
#define PCM_TIME  0x0001
#define PCM_TITLE 0x0002




class Gandharva : public GandharvaSettings
{
public:
  Gandharva( HWND parent, HINSTANCE lsinstance );
  ~Gandharva();

private:

  //void on(UINT, WPARAM, LPARAM);
  LRESULT onPaint(UINT, WPARAM, LPARAM);
  LRESULT onTimer(UINT, WPARAM, LPARAM);
  LRESULT onLmGetRevid(UINT, WPARAM, LPARAM);
  LRESULT onDisplayChange(UINT, WPARAM, LPARAM);
  LRESULT onMouse(UINT, WPARAM, LPARAM);
  LRESULT onCopyData(UINT, WPARAM, LPARAM);

  void BangProcessor(BANGID, LPSTR args);

  CPlayerDataContainer *m_pPlayer;

  DWORD ParseClickMap(int x, int y);
  BOOL MyParseBangCommand(char *);
  void SetWndPos();
  static LRESULT CALLBACK WndProc(HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam);
  LRESULT WindowProc(HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam);

  LRESULT ParseAmpCommand(DWORD command);

  //timer id & func
  UINT m_rtimer,m_stimer,m_wtimer;//refresh,scroll,waiting

  int m_nWaitCounter;

  //CommandProvider Token
  int m_token;

  //!Bang
  BANGSTRUCT bsBang,bsBangExt;
};

#endif //_H_GANDHARVA
